[![MIT License](https://img.shields.io/badge/license-MIT-blue.svg?style=flat)](LICENSE.md) [![NPM](https://img.shields.io/npm/v/openfl.svg?style=flat)](http://npmjs.com/package/openfl) [![Build Status](https://img.shields.io/circleci/project/github/openfl/openfl-js/master.svg)](https://circleci.com/gh/openfl/openfl-js)


OpenFL-JS
=========

OpenFL is a productive 2D development library, for interactive games and applications. It includes WebGL and canvas rendering for pixel and draw operations, display lists and other features supported by Adobe Flash Player, without requiring a runtime.

OpenFL-JS is a new effort to make [OpenFL](http://www.openfl.org) usable from ES5/JavaScript, ES6/JavaScript, TypeScript and Haxe. Haxe-based projects can leverage OpenFL to build for native desktop and mobile targets, while all languages can target the browser using CommonJS module imports.


Get Started
===========

OpenFL-JS includes [samples](https://github.com/openfl/openfl-js/tree/master/samples) for ES5, ES6, TypeScript and Haxe.

## Clone the repository

```bash
git clone https://github.com/openfl/openfl-js
```

## Change the directory to one of the samples

```bash
cd openfl-js/samples/typescript/helloworld
```

## Install and start

```bash
npm install
npm start
```


<br />
<p align="center"><img src="openfl.png"/></p>


Rebuilding the Library
======================

Releases of "openfl" on NPM include all of the generated CommonJS modules. If you have a clone of the repository, and wish to build these files, there are two ways to do it.

## Using Haxe, OpenFL and Lime locally

Install Haxe, OpenFL and Lime locally (must be OpenFL 6.5.4 or a development build), then run the following command:

```bash
npm run build
```

## Using Docker

If you have Docker installed on your system, you can rebuild the generated CommonJS modules without installing Haxe at all.

```
npm run docker-build
```


Running tests
=============

Before running tests, make sure you install dev dependencies

```bash
npm install
```

## Running all tests in a headless browser

```bash
npm run test
```

## Running specific tests in a headless browser

```bash
npm run test-es5
npm run test-es6
npm run test-haxe
npm run test-typescript
```

## Building tests (without running)

```bash
npm run build-test-es5
npm run build-test-es6
npm run build-test-haxe
npm run build-test-typescript
```

## Building and running tests using Docker instead

```bash
npm run docker-build-test-es5
npm run docker-build-test-es6
npm run docker-build-test-haxe
npm run docker-build-test-typescript
npm run docker-test
npm run docker-test-es5
npm run docker-test-es6
npm run docker-test-haxe
npm run docker-test-typescript
```


License
=======

OpenFL (and OpenFL-JS) are free, open-source software under the [MIT license](LICENSE.md).