// Class: lime.media.AudioBuffer

var $global = typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = require("./../../hxClasses_stub").default;
var $import = require("./../../import_stub").default;
function lime_app_Promise() {return require("./../../lime/app/Promise");}
function lime_app_Future() {return require("./../../lime/app/Future");}
function lime_utils_Log() {return require("./../../lime/utils/Log");}

// Constructor

var AudioBuffer = function() {
}

// Meta

AudioBuffer.__name__ = ["lime","media","AudioBuffer"];
AudioBuffer.prototype = {
	dispose: function() {
	},
	get_src: function() {
		return this.__srcAudio;
	},
	set_src: function(value) {
		return this.__srcAudio = value;
	}
};
AudioBuffer.prototype.__class__ = $hxClasses["lime.media.AudioBuffer"] = AudioBuffer;

// Init

{
	var p = AudioBuffer.prototype;
	Object.defineProperties(p,{ "src" : { get : p.get_src, set : p.set_src}});
};

// Statics

AudioBuffer.fromBase64 = function(base64String) {
	if(base64String == null) {
		return null;
	}
	return null;
}
AudioBuffer.fromBytes = function(bytes) {
	if(bytes == null) {
		return null;
	}
	return null;
}
AudioBuffer.fromFile = function(path) {
	if(path == null) {
		return null;
	}
	return null;
}
AudioBuffer.fromFiles = function(paths) {
	var buffer = null;
	var _g = 0;
	while(_g < paths.length) {
		var path = paths[_g];
		++_g;
		buffer = AudioBuffer.fromFile(path);
		if(buffer != null) {
			break;
		}
	}
	return buffer;
}
AudioBuffer.fromVorbisFile = function(vorbisFile) {
	return null;
}
AudioBuffer.loadFromFile = function(path) {
	var promise = new (lime_app_Promise().default)();
	var audioBuffer = AudioBuffer.fromFile(path);
	if(audioBuffer != null) {
		promise.complete(audioBuffer);
	} else {
		promise.error(null);
	}
	return promise.future;
}
AudioBuffer.loadFromFiles = function(paths) {
	var promise = new (lime_app_Promise().default)();
	promise.completeWith(new (lime_app_Future().default)(function() {
		return AudioBuffer.fromFiles(paths);
	},true));
	return promise.future;
}
AudioBuffer.__getCodec = function(bytes) {
	var signature = bytes.getString(0,4);
	switch(signature) {
	case "OggS":
		return "audio/ogg";
	case "RIFF":
		if(bytes.getString(8,4) == "WAVE") {
			return "audio/wav";
		} else if(bytes.getString(0,3) == "ID3" || bytes.getString(0,2) == "ÿû") {
			return "audio/mp3";
		}
		break;
	case "fLaC":
		return "audio/flac";
	default:
		if(bytes.getString(0,3) == "ID3" || bytes.getString(0,2) == "ÿû") {
			return "audio/mp3";
		}
	}
	(lime_utils_Log().default).error("Unsupported sound format",{ fileName : "AudioBuffer.hx", lineNumber : 492, className : "lime.media.AudioBuffer", methodName : "__getCodec"});
	return null;
}


// Export

exports.default = AudioBuffer;